import vrml.Event;
import vrml.field.ConstSFTime;
import vrml.field.ConstSFVec3f;
import vrml.field.SFTime;
import vrml.field.SFVec3f;
import vrml.node.Script;

public class LionMovie extends Script {
   SFTime startLion;
   SFTime stopLion;
   SFVec3f setLionPosition;
   boolean moving = false;
   float[] userPosition = new float[3];
   float[] lionPosition = new float[3];

   public void initialize() {
      this.startLion = (SFTime)((Script)this).getEventOut("startLion");
      this.stopLion = (SFTime)((Script)this).getEventOut("stopLion");
      this.setLionPosition = (SFVec3f)((Script)this).getEventOut("setLionPosition");
      this.lionPosition[0] = 0.0F;
      this.lionPosition[1] = 0.0F;
      this.lionPosition[2] = 0.0F;
   }

   public void processEvent(Event var1) {
      if (var1.getName().equals("touched")) {
         this.touched(var1);
      } else if (var1.getName().equals("interval")) {
         this.interval();
      } else {
         if (var1.getName().equals("getUserPosition")) {
            this.getUserPosition(var1);
         }

      }
   }

   void touched(Event var1) {
      double var2 = ((ConstSFTime)var1.getValue()).getValue();
      this.moving = !this.moving;
      if (this.moving) {
         this.startLion.setValue(var2);
      } else {
         this.stopLion.setValue(var2);
      }
   }

   void interval() {
      if (this.moving) {
         float var1 = this.userPosition[0] - this.lionPosition[0];
         float var2 = this.userPosition[1] - this.lionPosition[1];
         float var3 = this.userPosition[2] - this.lionPosition[2];
         float var4 = (float)Math.sqrt((double)(var1 * var1 + var2 * var2 + var3 * var3));
         if ((double)var4 < (double)3.0F) {
            return;
         }

         var1 /= var4;
         var2 /= var4;
         var3 /= var4;
         float[] var10000 = this.lionPosition;
         var10000[0] += var1;
         var10000 = this.lionPosition;
         var10000[1] += var2;
         var10000 = this.lionPosition;
         var10000[2] += var3;
         this.setLionPosition.setValue(this.lionPosition);
      }

   }

   void getUserPosition(Event var1) {
      ((ConstSFVec3f)var1.getValue()).getValue(this.userPosition);
   }
}
